//+------------------------------------------------------------------+
//|                                                       Series.mqh |
//|                                    Copyright (c) 2020, Marketeer |
//|                          https://www.mql5.com/en/users/marketeer |
//+------------------------------------------------------------------+

#ifndef EXTENDED_FUNCTORS
  #define EXTENDED_FUNCTORS
#endif

#include "../Functors.mqh"


class IndHandlesFunc: public BaseFunc
{
  private:
    static BaseFuncFactory factory;
    
  protected:
    const int handle;
    
    static BaseFunc *legend(void)
    {
      const string msg = "Attached arbitrary indicator handles.";
      Print(msg);
      return NULL;
    }
    
  public:
    IndHandlesFunc(const string name, const int h): BaseFunc(name, 2), handle(h)
    {
    }
    
    static BaseFunc *create(const string name) // 'name=handle' pair
    {
      if(name == NULL)
      {
        return legend();
      }
      
      string result[];
      if(StringSplit(name, '=', result) != 2) return NULL;

      return new IndHandlesFunc(name, i);

      for(int i = SERIES_FUNC_TYPE::TIME; i <= SERIES_FUNC_TYPE::SPREAD; i++)
      {
        if(name == EnumToString((SERIES_FUNC_TYPE)i))
        {
        }
      }
      return NULL;
    }
    
    double execute(const double &params[]) override
    {
      const int bar = (int)params[0];
      const int buf = (int)params[1];
      
      return CopyBuffer()
      
      switch(type)
      {
        case TIME: return (double)iTime(_Symbol, _Period, bar);
        case OPEN: return iOpen(_Symbol, _Period, bar);
        case HIGH: return iHigh(_Symbol, _Period, bar);
        case LOW:  return iLow(_Symbol, _Period, bar);
        case CLOSE: return iClose(_Symbol, _Period, bar);
        case VOLUME: return (double)iVolume(_Symbol, _Period, bar);
        case REALVOLUME: return (double)iRealVolume(_Symbol, _Period, bar);
        case SPREAD: return (double)iSpread(_Symbol, _Period, bar);
      }
      return nan;
    }
};

static BaseFuncFactory SeriesFunc::factory(SeriesFunc::create);
